/***************************************************************************
 *   Copyright (C) 2020 by Robert Middleton                                *
 *   robert.middleton@rm5248.com                                           *
 *                                                                         *
 *   This file is part of the dbus-cxx library.                            *
 *                                                                         *
 *   The dbus-cxx library is free software; you can redistribute it and/or *
 *   modify it under the terms of the GNU General Public License           *
 *   version 3 as published by the Free Software Foundation.               *
 *                                                                         *
 *   The dbus-cxx library is distributed in the hope that it will be       *
 *   useful, but WITHOUT ANY WARRANTY; without even the implied warranty   *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU   *
 *   General Public License for more details.                              *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this software. If not see <http://www.gnu.org/licenses/>.  *
 ***************************************************************************/
#ifndef DBUSCXX_INTROPSECTION_INTERFACE_PROXY_H
#define DBUSCXX_INTROPSECTION_INTERFACE_PROXY_H

#include "../interfaceproxy.h"
#include <memory>
#include <string>

namespace DBus {

class IntrospectableInterfaceProxy : public InterfaceProxy {
private:
    IntrospectableInterfaceProxy();

public:
    static std::shared_ptr<IntrospectableInterfaceProxy> create();

    std::string Introspect();

private:
    std::shared_ptr<MethodProxy<std::string()>> m_introspect_method;
};

}

#endif /* DBUSCXX_INTROPSECTION_INTERFACE_PROXY_H */
